Subject: Re: rsync hang - strace output - any ideas?
From: "Max Bowsher" <[email-masked]>
To: "Lapo Luchini" <[email-masked]>
Cc: <[email-masked]>
Date: Wed, 29 Jan 2003 17:16:59 -0000

Lapo Luchini wrote:
> Max Bowsher wrote:
>
>> I was running the rsync testsuite, and an rsync process hung.
>> I did "strace -p <pid>", and got 1 line of trace:
>>    4       4 [sig] rsync 2540 wait_sig: looping
>>
>> Does this mean anything to any Cygwin gurus?
>>
> What release are you using exactly?

2.5.6

> In 2.5.5-2 I added a small patch (don't remember the author, see the
> included README) that adds a sleepms(30) to try to avoid a (possible?)
> bug in signaling between parent and child in Cygwin.
> Some heavy user say that also with that sleepms(30) they sometime hang
> and that sleepms(100) "relsolved" that better, but this degrades
> performances.

I ran the rsync testsuite in a loop, and eventually got a hang, gdb-ed it,
got the backtrace and posted it here ([email-masked]). Based on that, I
do not think that the signalling between parent and child is at fault. As
best I can tell, something is going wrong in socketpair_tcp(), causing rsync
to end up blocked on accept(). It's probably some peculiarity of Winsock.

PS: Did you catch my message regarding pipe vs. socketpair? It might be an
idea to use pipe in 2.5.6-1 unless we can figure out why Cygwin's socketpair
doesn't always work.

Max.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Bug reporting:         http://cygwin.com/bugs.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/